
<h1 align="center">Tiny SEO Detector</h1>

<h5 align="center">A simple, flexible and configurable SEO (defects) detector</h5>

<div align="center">
  <a href="https://travis-ci.org/poepanda/tiny-seo-detector">
    <img src="https://travis-ci.org/poepanda/tiny-seo-detector.svg?branch=master" alt="Travis CI" />
  </a>
  <a href='https://coveralls.io/github/poepanda/tiny-seo-detector?branch=master'>
    <img src='https://coveralls.io/repos/github/poepanda/tiny-seo-detector/badge.svg?branch=master' alt='Coverage Status' />
  </a>
</div>

## How to install

Using npm
```
npm install tiny-seo-detector
```

or with Yarn
```
yarn add tiny-seo-detector
```

## Usage
```javascript
  const Detector = require('tiny-seo-detector');

  // Get an instance of Detector
  const myDetector = new Detector('<html><h1>Title</h1></html>');

  // Run the defects checker
  myDetector.defects();
```

## TODO
*Implmenetation*
- [X] Reader - From file, stream or text
- [X] Writer - To console, file or stream
- [X] Defects detector - with predefined rules
- [X] Configuration for rules
- [X] Configuration for rule definitions
- [X] Able to define new custom rules by primitive set of keys (required, requiredAttr, maxQuantity, ...)
- [X] Able to toggle or override current rules
- [X] Messages handling and scale-ready

*Tests*
- [X] Unit test - IO (Read + Write)
- [X] Unit test - Defects (Validating + rule defining)
- [X] Unit test - ultilities
- [X] Intergration tests

*Documentation*
- [ ] README - status
- [ ] README - How to install
- [ ] README - How to use / configuration
- [ ] README - Default configruation / rules definition
- [ ] README - Rule template 
- [ ] README - Define new rule
- [ ] Add license file